package com.link.core.contextholder;

import com.link.core.basic.service.BasicServiceException;
import com.link.core.util.RedisUtil;
import com.link.core.util.dynamicredis.RedisSource;
import com.link.core.util.redisclient.LinkRedisClient;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.function.BiFunction;
import java.util.function.Function;
import org.springframework.util.CollectionUtils;

public class RedisCompseUtils<R> {
   private final List<Function<LinkRedisClient, R>> dInjects = new ArrayList();
   private final List<Function<LinkRedisClient, Object>> dInjectsBack = new ArrayList();
   private final List<BiFunction<LinkRedisClient, Object, Object>> dInjectsBackByResult = new ArrayList();

   public static <R> RedisCompseUtils<R> builder() {
      return new RedisCompseUtils();
   }

   public void roolBackRedis(RedisSource redisSource) {
      RedisSecurityContextHolder.roolBack(redisSource);
   }

   public <R> R execute(RedisSource redisSource) {
      LinkRedisClient redisClient = null;

      try {
         if (this.dInjects.size() != 1 || CollectionUtils.isEmpty(this.dInjectsBack) && CollectionUtils.isEmpty(this.dInjectsBackByResult)) {
            throw new BasicServiceException("缓存操作异常，请检查操作信息");
         } else {
            redisClient = RedisUtil.getJedis(redisSource);
            R r = ((Function)this.dInjects.get(0)).apply(redisClient);
            Iterator var4 = this.dInjectsBack.iterator();

            while(var4.hasNext()) {
               Function<LinkRedisClient, Object> function = (Function)var4.next();
               RedisSecurityContextHolder.set(function);
            }

            var4 = this.dInjectsBackByResult.iterator();

            while(var4.hasNext()) {
               BiFunction<LinkRedisClient, Object, Object> biFunction = (BiFunction)var4.next();
               Function<LinkRedisClient, Object> function = (instance) -> {
                  return biFunction.apply(instance, r);
               };
               RedisSecurityContextHolder.set(function);
            }

            Object var13 = r;
            return var13;
         }
      } catch (Exception var10) {
         Exception e = var10;
         throw new BasicServiceException(e.getMessage());
      } finally {
         RedisUtil.returnResource(redisClient);
      }
   }

   public RedisCompseUtils<R> wilth(LkRdsFunctionP0 function0) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, R> function = (instance) -> {
            return function0.accept(instance);
         };
         this.dInjects.add(function);
         return this;
      }
   }

   public <P1> RedisCompseUtils<R> wilth(LkRdsFunctionP1 function1, P1 p1) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, R> function = (instance) -> {
            return function1.accept(instance, p1);
         };
         this.dInjects.add(function);
         return this;
      }
   }

   public <P1, P2> RedisCompseUtils<R> wilth(LkRdsFunctionP2 function2, P1 p1, P2 p2) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, R> function = (instance) -> {
            return function2.accept(instance, p1, p2);
         };
         this.dInjects.add(function);
         return this;
      }
   }

   public <P1, P2, P3> RedisCompseUtils<R> wilth(LkRdsFunctionP3 function3, P1 p1, P2 p2, P3 p3) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, R> function = (instance) -> {
            return function3.accept(instance, p1, p2, p3);
         };
         this.dInjects.add(function);
         return this;
      }
   }

   public <P1, P2, P3, P4> RedisCompseUtils<R> wilth(LkRdsFunctionP4 function4, P1 p1, P2 p2, P3 p3, P4 p4) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, R> function = (instance) -> {
            return function4.accept(instance, p1, p2, p3, p4);
         };
         this.dInjects.add(function);
         return this;
      }
   }

   public <P1, P2, P3, P4, P5> RedisCompseUtils<R> wilth(LkRdsFunctionP5 function5, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, R> function = (instance) -> {
            return function5.accept(instance, p1, p2, p3, p4, p5);
         };
         this.dInjects.add(function);
         return this;
      }
   }

   public RedisCompseUtils<R> wilthRoolBackByResult(LkRdsFunctionRbR functionRbR) {
      if (this.dInjectsBackByResult.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         BiFunction<LinkRedisClient, Object, Object> function = (instance, r) -> {
            return functionRbR.accept(instance, r);
         };
         this.dInjectsBackByResult.add(function);
         return this;
      }
   }

   public RedisCompseUtils<R> wilthRoolBack(LkRdsFunctionRbP0 function0) {
      if (this.dInjectsBack.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, Object> function = (instance) -> {
            return function0.accept(instance);
         };
         this.dInjectsBack.add(function);
         return this;
      }
   }

   public <P1> RedisCompseUtils<R> wilthRoolBack(LkRdsFunctionRbP1 function1, P1 p1) {
      if (this.dInjectsBack.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, Object> function = (instance) -> {
            return function1.accept(instance, p1);
         };
         this.dInjectsBack.add(function);
         return this;
      }
   }

   public <P1, P2> RedisCompseUtils<R> wilthRoolBack(LkRdsFunctionRbP2 function2, P1 p1, P2 p2) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, Object> function = (instance) -> {
            return function2.accept(instance, p1, p2);
         };
         this.dInjectsBack.add(function);
         return this;
      }
   }

   public <P1, P2, P3> RedisCompseUtils<R> wilthRoolBack(LkRdsFunctionRbP3 function3, P1 p1, P2 p2, P3 p3) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, Object> function = (instance) -> {
            return function3.accept(instance, p1, p2, p3);
         };
         this.dInjectsBack.add(function);
         return this;
      }
   }

   public <P1, P2, P3, P4> RedisCompseUtils<R> wilthRoolBack(LkRdsFunctionRbP4 function4, P1 p1, P2 p2, P3 p3, P4 p4) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, Object> function = (instance) -> {
            return function4.accept(instance, p1, p2, p3, p4);
         };
         this.dInjectsBack.add(function);
         return this;
      }
   }

   public <P1, P2, P3, P4, P5> RedisCompseUtils<R> wilthRoolBack(LkRdsFunctionRbP5 function5, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5) {
      if (this.dInjects.size() > 0) {
         throw new BasicServiceException("当前只能有单个操作");
      } else {
         Function<LinkRedisClient, Object> function = (instance) -> {
            return function5.accept(instance, p1, p2, p3, p4, p5);
         };
         this.dInjectsBack.add(function);
         return this;
      }
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbP5<P1, P2, P3, P4, P5> {
      Object accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5);
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbP4<P1, P2, P3, P4> {
      Object accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3, P4 p4);
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbP3<P1, P2, P3> {
      Object accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3);
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbP2<P1, P2> {
      Object accept(LinkRedisClient redis, P1 p1, P2 p2);
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbP1<P1> {
      Object accept(LinkRedisClient redis, P1 p1);
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbP0 {
      Object accept(LinkRedisClient redis);
   }

   @FunctionalInterface
   public interface LkRdsFunctionRbR<R> {
      Object accept(LinkRedisClient redis, R r);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP5<P1, P2, P3, P4, P5, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3, P4 p4, P5 p5);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP4<P1, P2, P3, P4, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3, P4 p4);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP3<P1, P2, P3, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2, P3 p3);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP2<P1, P2, R> {
      R accept(LinkRedisClient redis, P1 p1, P2 p2);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP1<P1, R> {
      R accept(LinkRedisClient redis, P1 p1);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP0<R> {
      R accept(LinkRedisClient redis);
   }
}
